Index: NEMO/branches/2019/dev_r11233_obsasm_docfixes/doc/latex/NEMO/subfiles/chap_ASM.tex
===================================================================
--- NEMO/branches/2019/dev_r11233_obsasm_docfixes/doc/latex/NEMO/subfiles/chap_ASM.tex	(revision 11307)
+++ NEMO/branches/2019/dev_r11233_obsasm_docfixes/doc/latex/NEMO/subfiles/chap_ASM.tex	(revision 11311)
@@ -15,5 +15,5 @@
 \begin{tabular}{l||l|m{0.65\linewidth}}
     Release   & Author        & Modifications \\
-    {\em 4.0} & {\em D. J. Lea} & {\em NEMO 4.0 updates}  \\
+    {\em 4.0} & {\em D. J. Lea} & {\em \NEMO 4.0 updates}  \\
     {\em 3.4} & {\em D. J. Lea, M. Martin, K. Mogensen, A. Weaver} & {\em Initial version}  \\
 \end{tabular}
Index: NEMO/branches/2019/dev_r11233_obsasm_docfixes/doc/latex/NEMO/subfiles/chap_OBS.tex
===================================================================
--- NEMO/branches/2019/dev_r11233_obsasm_docfixes/doc/latex/NEMO/subfiles/chap_OBS.tex	(revision 11307)
+++ NEMO/branches/2019/dev_r11233_obsasm_docfixes/doc/latex/NEMO/subfiles/chap_OBS.tex	(revision 11311)
@@ -15,5 +15,5 @@
 \begin{tabular}{l||l|m{0.65\linewidth}}
     Release   & Author        & Modifications \\
-    {\em 4.0} & {\em D. J. Lea} & {\em NEMO 4.0 updates}  \\
+    {\em 4.0} & {\em D. J. Lea} & {\em \NEMO 4.0 updates}  \\
     {\em 3.6} & {\em M. Martin, A. Ryan} & {\em Add averaging operator, standalone obs oper} \\
     {\em 3.4} & {\em D. J. Lea, M. Martin, ...} & {\em Initial version}  \\
@@ -25,11 +25,11 @@
 
 The observation and model comparison code, the observation operator (OBS), reads in observation files
-(profile temperature and salinity, sea surface temperature, sea level anomaly, sea ice concentration, and velocity) and calculates an interpolated model equivalent value at the observation location and nearest model timestep.
+(profile temperature and salinity, sea surface temperature, sea level anomaly, sea ice concentration, and velocity) and calculates an interpolated model equivalent value at the observation location and nearest model time step.
 The resulting data are saved in a ``feedback'' file (or files).
 The code was originally developed for use with the NEMOVAR data assimilation code,
 but can be used for validation or verification of the model or with any other data assimilation system.
 
-The OBS code is called from \mdl{nemogcm} for model initialisation and to calculate the model equivalent values for observations on the 0th timestep.
-The code is then called again after each timestep from \mdl{step}.
+The OBS code is called from \mdl{nemogcm} for model initialisation and to calculate the model equivalent values for observations on the 0th time step.
+The code is then called again after each time step from \mdl{step}.
 The code is only activated if the \ngn{namobs} namelist logical \np{ln\_diaobs} is set to true.
 
@@ -46,17 +46,17 @@
 the observation operator code can calculate equivalent night-time average model SST fields by
 setting the namelist value \np{ln\_sstnight} to true.
-Otherwise (by default) the model value from the nearest timestep to the observation time is used.
+Otherwise (by default) the model value from the nearest time step to the observation time is used.
 
 The code is controlled by the namelist \ngn{namobs}.
 See the following sections for more details on setting up the namelist.
 
-\autoref{sec:OBS_example} introduces a test example of the observation operator code including
+In \autoref{sec:OBS_example} a test example of the observation operator code is introduced, including
 where to obtain data and how to setup the namelist.
-\autoref{sec:OBS_details} introduces some more technical details of the different observation types used and
-also shows a more complete namelist.
-\autoref{sec:OBS_theory} introduces some of the theoretical aspects of the observation operator including
+In \autoref{sec:OBS_details} some more technical details of the different observation types used are introduced, and we
+also show a more complete namelist.
+In \autoref{sec:OBS_theory} some of the theoretical aspects of the observation operator are described including
 interpolation methods and running on multiple processors.
-\autoref{sec:OBS_sao} describes the standalone observation operator code.
-\autoref{sec:OBS_obsutils} introduces some utilities to help working with the files produced by the OBS code.
+In \autoref{sec:OBS_sao} the standalone observation operator code is described.
+In \autoref{sec:OBS_obsutils} we describe some utilities to help work with the files produced by the OBS code.
 
 % ================================================================
@@ -68,5 +68,5 @@
 In this section an example of running the observation operator code is described using
 profile observation data which can be freely downloaded.
-It shows how to adapt an existing run and build of NEMO to run the observation operator. Note also the observation operator and the assimilation increments code are run in the \np{ORCA2\_ICE\_OBS} SETTE test.
+It shows how to adapt an existing run and build of \NEMO to run the observation operator. Note also the observation operator and the assimilation increments code are run in the \np{ORCA2\_ICE\_OBS} SETTE test.
 
 \begin{enumerate}
@@ -89,5 +89,5 @@
 \end{cmds}
 
-\item Include the following in the NEMO namelist to run the observation operator on this data:
+\item Include the following in the \NEMO namelist to run the observation operator on this data:
 \end{enumerate}
 
@@ -108,5 +108,5 @@
 A number of utilities are now provided to plot the feedback files, convert and recombine the files.
 These are explained in more detail in \autoref{sec:OBS_obsutils}.
-Utilites to convert other input data formats into the feedback format are also described in
+Utilities to convert other input data formats into the feedback format are also described in
 \autoref{sec:OBS_obsutils}.
 
@@ -558,5 +558,5 @@
 In those cases the model counterpart should be calculated by averaging the model grid points over
 the same size as the footprint.
-NEMO therefore has the capability to specify either an interpolation or an averaging
+\NEMO therefore has the capability to specify either an interpolation or an averaging
 (for surface observation types only).
 
@@ -585,8 +585,8 @@
 \subsubsection{Horizontal interpolation}
 
-Consider an observation point ${\mathrm P}$ with with longitude and latitude (${\lambda_{}}_{\mathrm P}$, $\phi_{\mathrm P}$) and
+Consider an observation point ${\mathrm P}$ with longitude and latitude (${\lambda_{}}_{\mathrm P}$, $\phi_{\mathrm P}$) and
 the four nearest neighbouring model grid points ${\mathrm A}$, ${\mathrm B}$, ${\mathrm C}$ and ${\mathrm D}$ with
 longitude and latitude ($\lambda_{\mathrm A}$, $\phi_{\mathrm A}$),($\lambda_{\mathrm B}$, $\phi_{\mathrm B}$) etc.
-All horizontal interpolation methods implemented in NEMO estimate the value of a model variable $x$ at point $P$ as
+All horizontal interpolation methods implemented in \NEMO estimate the value of a model variable $x$ at point $P$ as
 a weighted linear combination of the values of the model variables at the grid points ${\mathrm A}$, ${\mathrm B}$ etc.:
 
@@ -680,5 +680,5 @@
   the averaging is likely need to cover.
 \item The longitudes and latitudes of the grid points surrounding the nearest model grid box are extracted using
-  existing mpi routines.
+  existing MPI routines.
 \item The weights for each grid point associated with each observation are calculated,
   either for radial or rectangular footprints.
@@ -723,5 +723,5 @@
 \subsection{Grid search}
 
-For many grids used by the NEMO model, such as the ORCA family, the horizontal grid coordinates $i$ and $j$ are not simple functions of latitude and longitude.
+For many grids used by the \NEMO model, such as the ORCA family, the horizontal grid coordinates $i$ and $j$ are not simple functions of latitude and longitude.
 Therefore, it is not always straightforward to determine the grid points surrounding any given observational position.
 Before the interpolation can be performed, a search algorithm is then required to determine the corner points of
@@ -845,5 +845,5 @@
 At the bottom boundary, this is done using the land-ocean mask.
 
-For profile observation types we do both vertical and horizontal interpolation. NEMO has a generalised vertical coordinate system this means the vertical level depths can vary with location. Therefore, it is necessary first to perform vertical interpolation of the model value to the observation depths for each of the four surrounding grid points. After this the model values, at these points, at the observation depth, are horizontally interpolated to the observation location.
+For profile observation types we do both vertical and horizontal interpolation. \NEMO has a generalised vertical coordinate system this means the vertical level depths can vary with location. Therefore, it is necessary first to perform vertical interpolation of the model value to the observation depths for each of the four surrounding grid points. After this the model values, at these points, at the observation depth, are horizontally interpolated to the observation location.
 
 \newpage
@@ -862,5 +862,5 @@
 The observation operator maps model variables to observation space. This is normally done while the model is running, i.e. online, it is possible to apply this mapping offline without running the model with the \textbf{standalone observation operator} (SAO). The process is divided into an initialisation phase, an interpolation phase and an output phase.
 During the interpolation phase the SAO populates the model arrays by
-reading saved model fields from disk. The interpolation and the output phases use the same OBS code described in the preceeding sections.
+reading saved model fields from disk. The interpolation and the output phases use the same OBS code described in the preceding sections.
 
 There are two ways of exploiting the standalone capacity.
@@ -893,5 +893,5 @@
 
 The simplest way to use the executable is to edit and append the \textbf{sao.nml} namelist to
-a full NEMO namelist and then to run the executable as if it were nemo.exe.
+a full \NEMO namelist and then to run the executable as if it were nemo.exe.
 
 %--------------------------------------------------------------------------------------------------------
@@ -900,7 +900,5 @@
 \subsection{Configuring the standalone observation operator}
 The observation files and settings understood by \ngn{namobs} have been outlined in the online observation operator section.
-In addition there are two further namelists wich control the operation of the SAO.
-\textbf{namsao} which controls the input model fields and \textbf{namcl4} which
-controls the production of class 4 files.
+In addition is a further namelist \ngn{namsao} which used to set the input model fields for the SAO
 
 \subsubsection{Single field}
@@ -912,5 +910,5 @@
 \textbf{votemper}, \textbf{vosaline} and optionally \textbf{sshn} present.
 
-For each field read there must be an entry in the \textbf{namsao} namelist specifying
+For each field read there must be an entry in the \ngn{namsao} namelist specifying
 the name of the file to read and the index along the \emph{time\_counter}.
 For example, to read the second time counter from a single file the namelist would be.
@@ -959,7 +957,7 @@
 If all that is needed is a single model counterpart at a regular interval then
 the standard SAO is all that is required.
-However, it is possible to extend this approach by comparing multiple forecasts, analyses, persisted analyses and
+However, just to note, it is possible to extend this approach by comparing multiple forecasts, analyses, persisted analyses and
 climatologies with the same set of observations.
-This approach is referred to as \emph{Class 4} since it is the fourth metric defined by the GODAE intercomparison project. This requires multiple runs of the SAO and running an additional utility (not currently in the NEMO repository) to combine the feedback files into one class 4 file.
+This approach is referred to as \emph{Class 4} since it is the fourth metric defined by the GODAE intercomparison project. This requires multiple runs of the SAO and running an additional utility (not currently in the \NEMO repository) to combine the feedback files into one class 4 file.
 
 \newpage
@@ -969,5 +967,5 @@
 
 For convenience some tools for viewing and processing of observation and feedback files are provided in
-the NEMO repository.
+the \NEMO repository.
 These tools include OBSTOOLS which are a collection of \fortran programs which are helpful to deal with feedback files.
 They do such tasks as observation file conversion, printing of file contents,
@@ -979,6 +977,6 @@
 \subsection{Obstools}
 
-A series of \fortran utilities is provided with NEMO called OBSTOOLS.
-This are helpful in handling observation files and the feedback file output from the NEMO observation operator. A brief description of some of the utilities follows
+A series of \fortran utilities is provided with \NEMO called OBSTOOLS.
+This are helpful in handling observation files and the feedback file output from the observation operator. A brief description of some of the utilities follows
 
 \subsubsection{corio2fb}
@@ -1003,5 +1001,5 @@
 
 The program fbcomb combines multiple feedback files produced by individual processors in
-an MPI run of NEMO into a single feedback file.
+an MPI run of \NEMO into a single feedback file.
 It is called in the following way:
 
@@ -1134,5 +1132,5 @@
 The plotting colour range can be changed by clicking on the colour bar.
 The title of the plot gives some basic information about the date range and depth range shown,
-the extreme values, and the mean and rms values.
+the extreme values, and the mean and RMS values.
 It is possible to zoom in using a drag-box.
 You may also zoom in or out using the mouse wheel.