Index: NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/cfgs/ORCA2_ICE_ABL/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/cfgs/ORCA2_ICE_ABL/EXPREF/namelist_cfg	(revision 11320)
+++ NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/cfgs/ORCA2_ICE_ABL/EXPREF/namelist_cfg	(revision 11322)
@@ -112,15 +112,15 @@
    !           !  file name              ! frequency (hours) ! variable  ! time interp.!  clim  ! 'yearly'/ !          weights filename            ! rotation ! land/sea mask !
    !           !                         !  (if <0  months)  !   name    !   (logical) !  (T/F) ! 'monthly' !                                      ! pairing  !    filename   !
-   sn_wndi     = 'abl_erai_1d'                ,   6.        , 'uwnd'  ,   .false.   , .true. , 'yearly'  , 'weight_erai_3d_bicubic' , 'Uwind'
-   sn_wndj     = 'abl_erai_1d'                ,   6.        , 'vwnd'  ,   .false.   , .true. , 'yearly'  , 'weight_erai_3d_bicubic' , 'Vwind'
-   sn_qsr      = 'ncar_rad.15JUNE2009_fill'   ,   24.        , 'SWDN_MOD',   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
-   sn_qlw      = 'ncar_rad.15JUNE2009_fill'   ,   24.        , 'LWDN_MOD',   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
-   sn_tair     = 'abl_erai_1d'                ,   6.        , 'tair'  ,   .false.   , .true. , 'yearly'  , 'weight_erai_3d_bilin' , ''
-   sn_humi     = 'abl_erai_1d'                ,   6.        , 'humi'  ,   .false.   , .true. , 'yearly'  , 'weight_erai_3d_bilin' , ''
-   sn_prec     = 'ncar_precip.15JUNE2009_fill',   -1.        , 'PRC_MOD1',   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
+   sn_wndi     = 'ABLdta_erai_1d'                ,   6.        , 'uwnd'  ,   .false.   , .true. , 'yearly'  ,  'weight_ERAI_GLOBALF128_2_ORCA2_bicubic.nc' , 'Uwind'
+   sn_wndj     = 'ABLdta_erai_1d'                ,   6.        , 'vwnd'  ,   .false.   , .true. , 'yearly'  , 'weight_ERAI_GLOBALF128_2_ORCA2_bicubic.nc' , 'Vwind'
+   sn_qsr       = 'ncar_rad.15JUNE2009_fill'   ,   24.        , 'SWDN_MOD',   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
+   sn_qlw       = 'ncar_rad.15JUNE2009_fill'   ,   24.        , 'LWDN_MOD',   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
+   sn_tair       = 'ABLdta_erai_1d'                ,   6.        , 'tair'  ,   .false.   , .true. , 'yearly'  , 'weight_ERAI_GLOBALF128_2_ORCA2_bilinear.nc' , ''
+   sn_humi     = 'ABLdta_erai_1d'                ,   6.        , 'humi'  ,   .false.   , .true. , 'yearly'  , 'weight_ERAI_GLOBALF128_2_ORCA2_bilinear.nc' , ''
+   sn_prec      = 'ncar_precip.15JUNE2009_fill',   -1.        , 'PRC_MOD1',   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
    sn_snow     = 'ncar_precip.15JUNE2009_fill',   -1.        , 'SNOW'    ,   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
-   sn_slp      = 'slp.15JUNE2009_fill'        ,    6.        , 'SLP'     ,   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
-!   sn_hpgi     = 'abl_erai_1d'                ,   6.        , 'uhpg'  ,   .false.   , .true. , 'yearly'  , 'weight_erai_3d_bicubic' , 'Uhpg'       , ''
-!   sn_hpgj     = 'abl_erai_1d'                ,   6.        , 'vhpg'  ,   .false.   , .true. , 'yearly'  , 'weight_erai_3d_bicubic' , 'Vhpg'       , ''
+   sn_slp        = 'slp.15JUNE2009_fill'        ,    6.        , 'SLP'     ,   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
+   sn_hpgi     = 'ABLdta_erai_1d'                ,   6.        , 'uhpg'  ,   .false.   , .true. , 'yearly'  , 'weight_ERAI_GLOBALF128_2_ORCA2_bicubic.nc' , 'Uhpg'       , ''
+   sn_hpgj     = 'ABLdta_erai_1d'                ,   6.        , 'vhpg'  ,   .false.   , .true. , 'yearly'  , 'weight_ERAI_GLOBALF128_2_ORCA2_bicubic.nc' , 'Vhpg'       , ''
 /
 
@@ -130,11 +130,11 @@
    cn_dir         = './'      !  root directory for the location of the ABL grid file
    cn_dom         = 'dom_cfg_abl_L50Z10.nc'
-   ln_hpgls_frc   = .false.
+   ln_hpgls_frc   = .true.
    ln_geos_winds  = .false.
-   nn_dyn_restore = 2
-   rn_ldyn_min   =  16.       !  magnitude of the nudging on ABL dynamics at the bottom of the ABL   [hour]
-   rn_ldyn_max   =  1.6       !  magnitude of the nudging on ABL dynamics at the top of the ABL   [hour]
-   rn_ltra_min   =  16.       !  magnitude of the nudging on ABL tracers  at the bottom of the ABL   [hour]
-   rn_ltra_max   =  1.6       !  magnitude of the nudging on ABL tracers  at the top of the ABL   [hour]
+   nn_dyn_restore = 1
+   rn_ldyn_min   =  7.5       !  magnitude of the nudging on ABL dynamics at the bottom of the ABL   [hour]
+   rn_ldyn_max   =  1.5       !  magnitude of the nudging on ABL dynamics at the top of the ABL   [hour]
+   rn_ltra_min   =  7.5       !  magnitude of the nudging on ABL tracers  at the bottom of the ABL   [hour]
+   rn_ltra_max   =  1.5       !  magnitude of the nudging on ABL tracers  at the top of the ABL   [hour]
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/cfgs/SHARED/namelist_ref
===================================================================
--- NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/cfgs/SHARED/namelist_ref	(revision 11320)
+++ NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/cfgs/SHARED/namelist_ref	(revision 11322)
@@ -301,4 +301,5 @@
    rn_Rod        = 0.15       ! c0 in RMCA17 mixing length formulation (not yet implemented)
    rn_Ric        = 0.139      !  Critical Richardson number (to compute PBL height and diffusivities)
+   ln_smth_pblh  = .false.    !  Smoothing of PBL height with a 2d Hanning filter
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/ABL/ablmod.F90
===================================================================
--- NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/ABL/ablmod.F90	(revision 11320)
+++ NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/ABL/ablmod.F90	(revision 11322)
@@ -81,7 +81,8 @@
       !
       REAL(wp), DIMENSION(1:jpi,1:jpj   )        ::   zrhoa, zwnd_i, zwnd_j
-      REAL(wp), DIMENSION(1:jpi,1:jpka  )        ::   zFC
+!      REAL(wp), DIMENSION(1:jpi,1:jpka  )        ::   zFC
       REAL(wp), DIMENSION(1:jpi,2:jpka  )        ::   zCF    
-      REAL(wp), DIMENSION(1:jpi,  jptq  )        ::   zBC
+!      REAL(wp), DIMENSION(1:jpi,  jptq  )        ::   zBC
+      REAL(wp), DIMENSION(1:jpi,1:jpj,1:jpka)     ::   z_cft      !--FL--to be removed after the test phase   
       !
       REAL(wp), DIMENSION(1:jpi,1:jpka  )        ::   z_elem_a
@@ -89,10 +90,7 @@
       REAL(wp), DIMENSION(1:jpi,1:jpka  )        ::   z_elem_c
       !
-      REAL(wp), DIMENSION(1:jpi,1:jpj,1:jpka )   ::   z_cft  !--FL--to be removed after the test phase
-      !
       INTEGER             ::   ji, jj, jk, jtra, jbak               ! dummy loop indices
       REAL(wp)            ::   zztmp, zcff, ztemp, zhumi, zcff1
       REAL(wp)            ::   zcff2, zfcor, zmsk, zsig, zcffu, zcffv
-      LOGICAL             ::   ln_old_coriolis  = .FALSE.              ! possibility to switch off Coriolis term       
       !
       !!---------------------------------------------------------------------      
@@ -211,14 +209,14 @@
          DO jj = 1, jpj
             DO ji = 1, jpi           
-               zcff = ( ff_t(ji,jj) * rdt )*( ff_t(ji,jj) * rdt )  ! (f dt)**2
+               zcff = ( fft_abl(ji,jj) * rdt )*( fft_abl(ji,jj) * rdt )  ! (f dt)**2
       
                u_abl( ji, jj, jk, nt_a ) = e3t_abl(jk) *(  &
                   &        (1._wp-gamma_Cor*(1._wp-gamma_Cor)*zcff)*u_abl( ji, jj, jk, nt_n )    &
-                  &                 +  rdt * ff_t(ji, jj) * v_abl ( ji , jj  , jk, nt_n ) )  &
+                  &                 +  rdt * fft_abl(ji, jj) * v_abl ( ji , jj  , jk, nt_n ) )  &
                   &                               / (1._wp + gamma_Cor*gamma_Cor*zcff)
                   
                v_abl( ji, jj, jk, nt_a ) =  e3t_abl(jk) *(  &
                   &        (1._wp-gamma_Cor*(1._wp-gamma_Cor)*zcff)*v_abl( ji, jj, jk, nt_n )   &
-                  &                 -  rdt * ff_t(ji, jj) * u_abl ( ji   , jj, jk, nt_n )  ) &
+                  &                 -  rdt * fft_abl(ji, jj) * u_abl ( ji   , jj, jk, nt_n )  ) &
                   &                                / (1._wp + gamma_Cor*gamma_Cor*zcff)                
             END DO
@@ -234,7 +232,7 @@
                DO ji = 1, jpi 
                   u_abl( ji, jj, jk, nt_a ) = u_abl( ji, jj, jk, nt_a )   &
-                     &                      - rdt * e3t_abl(jk) * ff_t(ji  , jj) * pgv_dta(ji  ,jj  ,jk)
+                     &                      - rdt * e3t_abl(jk) * fft_abl(ji  , jj) * pgv_dta(ji  ,jj  ,jk)
                   v_abl( ji, jj, jk, nt_a ) = v_abl( ji, jj, jk, nt_a )   &
-                     &                      + rdt * e3t_abl(jk) * ff_t(ji, jj  ) * pgu_dta(ji  ,jj  ,jk)
+                     &                      + rdt * e3t_abl(jk) * fft_abl(ji, jj  ) * pgu_dta(ji  ,jj  ,jk)
                END DO
             END DO
@@ -394,4 +392,6 @@
                   zcff  = (1._wp-zmsk) + zmsk * rdt * zcff2   ! zcff = 1 for masked points
                   
+				  zcff  = zcff * rest_eq(ji,jj) ; z_cft( ji, jj, jk ) = zcff
+				  
                   u_abl( ji, jj, jk, nt_a ) = (1._wp - zcff ) *  u_abl( ji, jj, jk, nt_a )   &
                      &                               + zcff   * pu_dta( ji, jj, jk       )                      
@@ -423,5 +423,5 @@
                   &                                       + zcff   * pq_dta( ji, jj, jk )
                
-               z_cft( ji, jj, jk ) = zcff
+               ! z_cft( ji, jj, jk ) = zcff
             END DO
          END DO
@@ -472,5 +472,5 @@
          DO ji = 1, jpi      
             zcff          = SQRT(  zwnd_i(ji,jj) * zwnd_i(ji,jj)   &
-               &                 + zwnd_j(ji,jj) * zwnd_j(ji,jj)  ) * msk_abl(ji,jj)
+               &                 + zwnd_j(ji,jj) * zwnd_j(ji,jj)  )  ! * msk_abl(ji,jj)
             zztmp         = zrhoa(ji,jj) * pcd_du(ji,jj)
             
@@ -504,4 +504,5 @@
          CALL prt_ctl( tab2d_2=ptauj  , clinfo2=          'vtau   : ' )
       ENDIF
+	  
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       !                            !  8 *** Swap time indices for the next timestep
@@ -509,5 +510,5 @@
       nt_n = 1 + MOD( kt  , 2)
       nt_a = 1 + MOD( kt+1, 2)
-      !
+      !	  
 !---------------------------------------------------------------------------------------------------
    END SUBROUTINE abl_stp
@@ -673,9 +674,10 @@
                zcff1 = zcff / ( zcff + rn_epssfc * pblh ( ji, jj ) )
                zcff  = ghw_abl( jk   )
+               zcff2 = zcff / ( zcff + rn_epssfc * pblh ( ji, jj ) )
                zFC( ji, jk ) = zFC( ji, jk-1) + 0.5_wp * e3t_abl( jk )*(                 &
                                zcff2 * ( zsh2( ji, jk  ) - ziRic * zbn2( ji, jj, jk   ) &
-                           - rn_Cek  * ( ff_t( ji, jj  ) * ff_t( ji, jj ) ) ) &
+                           - rn_Cek  * ( fft_abl( ji, jj  ) * fft_abl( ji, jj ) ) ) &
                              + zcff1 * ( zsh2( ji, jk-1) - ziRic * zbn2( ji, jj, jk-1 ) &
-                           - rn_Cek  * ( ff_t( ji, jj  ) * ff_t( ji, jj ) ) ) &
+                           - rn_Cek  * ( fft_abl( ji, jj  ) * fft_abl( ji, jj ) ) ) &
                            &                                                 )
                IF( ikbl(ji) == 0 .and. zFC( ji, jk ).lt.0._wp ) ikbl(ji)=jk
@@ -700,5 +702,10 @@
       !-------------      
       END DO      
-      !------------- 
+      !-------------
+	  IF(ln_smth_pblh) THEN
+	     CALL lbc_lnk( 'ablmod', pblh, 'T', 1.)
+	     CALL smooth_pblh( pblh, msk_abl )
+	     CALL lbc_lnk( 'ablmod', pblh, 'T', 1.)	  
+	  ENDIF
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       !                            !  Diagnostic mixing length computation
@@ -886,4 +893,70 @@
 
 
+!===================================================================================================
+   SUBROUTINE smooth_pblh( pvar2d, msk )
+!---------------------------------------------------------------------------------------------------
+
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE smooth_pblh  ***
+      !!
+      !! ** Purpose :   2D Hanning filter on atmospheric PBL height
+      !!
+      !! ---------------------------------------------------------------------
+	  REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: msk   
+	  REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: pvar2d
+      INTEGER                                     :: ji,jj
+	  REAL(wp)                                    :: smth_a, smth_b
+	  REAL(wp), DIMENSION(jpi,jpj)                :: zdX,zdY,zFX,zFY
+	  REAL(wp)                                    :: zumsk,zvmsk
+      !!
+      !!=========================================================
+      !!
+      !! Hanning filter
+      smth_a = 1._wp / 8._wp
+      smth_b = 1._wp / 4._wp
+      !
+      DO jj=1,jpj
+         DO ji=1,jpi-1
+            zumsk = msk(ji,jj) * msk(ji+1,jj)
+            zdX ( ji, jj ) = ( pvar2d( ji+1,jj ) - pvar2d( ji  ,jj ) ) * zumsk
+         END DO
+      END DO	  
+      
+	  DO jj=1,jpj-1
+         DO ji=1,jpi
+            zvmsk = msk(ji,jj) * msk(ji,jj+1)
+            zdY ( ji, jj ) = ( pvar2d( ji, jj+1 ) - pvar2d( ji  ,jj ) ) * zvmsk
+         END DO
+      END DO
+      
+	  DO jj=1,jpj-1
+         DO ji=2,jpi-1
+            zFY ( ji, jj  ) =   zdY ( ji, jj   )                        &
+               & +  smth_a*  ( (zdX ( ji, jj+1 ) - zdX( ji-1, jj+1 ))   &
+               &            -  (zdX ( ji, jj   ) - zdX( ji-1, jj   ))  )
+         END DO
+      END DO
+
+      DO jj=2,jpj-1
+         DO ji=1,jpi-1
+            zFX( ji, jj  ) =    zdX( ji, jj   )                         &
+              &    + smth_a*(  (zdY( ji+1, jj ) - zdY( ji+1, jj-1))     &
+              &             -  (zdY( ji  , jj ) - zdY( ji  , jj-1)) )
+         END DO
+      END DO	  
+
+	  DO jj = 2, jpj-1
+         DO ji = 2,jpi-1
+            pvar2d( ji  ,jj ) = pvar2d( ji  ,jj )              &
+     &         + msk(ji,jj) * smth_b * (                       &
+     &                  zFX( ji, jj ) - zFX( ji-1, jj )        &
+     &                 +zFY( ji, jj ) - zFY( ji, jj-1 )  )
+         END DO
+      END DO  
+	  !!
+!---------------------------------------------------------------------------------------------------
+   END SUBROUTINE smooth_pblh
+!===================================================================================================
+
 !!======================================================================
 END MODULE ablmod
Index: NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/ABL/par_abl.F90
===================================================================
--- NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/ABL/par_abl.F90	(revision 11320)
+++ NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/ABL/par_abl.F90	(revision 11322)
@@ -26,4 +26,5 @@
    LOGICAL , PUBLIC            ::   ln_geos_winds  !: large-scale restoring of ABL winds toward geostrophic winds
    LOGICAL , PUBLIC            ::   ln_hpgls_frc   !: forcing of ABL winds by large-scale pressure gradient 
+   LOGICAL , PUBLIC            ::   ln_smth_pblh   !: smoothing of atmospheric PBL height 
 
    !!---------------------------------------------------------------------
Index: NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/ABL/sbcabl.F90
===================================================================
--- NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/ABL/sbcabl.F90	(revision 11320)
+++ NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/ABL/sbcabl.F90	(revision 11322)
@@ -64,5 +64,6 @@
          &                 nn_dyn_restore,                                        &
          &                 rn_ldyn_min , rn_ldyn_max, rn_ltra_min, rn_ltra_max,   &
-         &                 nn_amxl, rn_cm, rn_ct, rn_ce, rn_ceps, rn_Rod, rn_Ric 
+         &                 nn_amxl, rn_cm, rn_ct, rn_ce, rn_ceps, rn_Rod, rn_Ric, &
+         &                 ln_smth_pblh		 
       !!---------------------------------------------------------------------
 
@@ -113,4 +114,6 @@
          END SELECT
          !
+		 IF( ln_smth_pblh )  WRITE(numout,*) '      ABL -- Smoothing of PBL height is activated'   
+		 !
       ENDIF
 
@@ -271,5 +274,5 @@
       !ENDIF
       !!GS restart case not supported
-
+	  
    END SUBROUTINE sbc_abl_init
 
@@ -339,5 +342,4 @@
    END SUBROUTINE sbc_abl
 
-
    !!======================================================================
 END MODULE sbcabl
Index: NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/ICE/icesbc.F90
===================================================================
--- NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/ICE/icesbc.F90	(revision 11320)
+++ NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/ICE/icesbc.F90	(revision 11322)
@@ -74,5 +74,9 @@
             &                                      sf(jp_tair)%fnow(:,:,1), sf(jp_humi)%fnow(:,:,1), sf(jp_slp)%fnow(:,:,1),   &
             &                                      u_ice, v_ice,   &    ! inputs
-            &                                      putaui = utau_ice, pvtaui = vtau_ice )    ! outputs                              ! Bulk         formulation
+            &                                      putaui = utau_ice, pvtaui = vtau_ice )    ! outputs                             
+         CASE( jp_abl     )   ;    CALL blk_ice_1( sf(jp_wndi)%fnow(:,:,1), sf(jp_wndj)%fnow(:,:,1),   &
+            &                                      sf(jp_tair)%fnow(:,:,1), sf(jp_humi)%fnow(:,:,1), sf(jp_slp)%fnow(:,:,1),   &
+            &                                      u_ice, v_ice,   &    ! inputs
+            &                                      putaui = utau_ice, pvtaui = vtau_ice )    ! outputs  
          CASE( jp_purecpl )   ;    CALL sbc_cpl_ice_tau( utau_ice , vtau_ice )   ! Coupled      formulation
       END SELECT
@@ -142,5 +146,5 @@
       CASE( jp_usr )              !--- user defined formulation
                                   CALL usrdef_sbc_ice_flx( kt, h_s, h_i )
-      CASE( jp_blk )              !--- bulk formulation
+      CASE( jp_blk, jp_abl )  !--- bulk formulation (temporary version for ABL option)
                                   CALL blk_ice_2    ( t_su, h_s, h_i, alb_ice, sf(jp_tair)%fnow(:,:,1), sf(jp_humi)%fnow(:,:,1),    &
             &                                           sf(jp_slp)%fnow(:,:,1), sf(jp_qlw)%fnow(:,:,1), sf(jp_prec)%fnow(:,:,1), sf(jp_snow)%fnow(:,:,1) )    ! 
Index: NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/OCE/SBC/sbcblk.F90
===================================================================
--- NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/OCE/SBC/sbcblk.F90	(revision 11320)
+++ NEMO/branches/2019/dev_r11265_ASINTER-01_Guillaume_ABL1D/src/OCE/SBC/sbcblk.F90	(revision 11322)
@@ -477,5 +477,5 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zztmp = zU_zu(ji,jj) * tmask(ji,jj,1)
+               zztmp = zU_zu(ji,jj) !* tmask(ji,jj,1)
                wndm(ji,jj)   = zztmp                   ! Store zU_zu in wndm to compute ustar2 in ablmod 
                pcd_du(ji,jj) = zztmp * Cd_atm(ji,jj)
@@ -639,6 +639,6 @@
          CALL prt_ctl(tab2d_1=zqla , clinfo1=' blk_oce_2: zqla  : ', tab2d_2=qsr  , clinfo2=' qsr   : ')
          CALL prt_ctl(tab2d_1=emp  , clinfo1=' blk_oce_2: emp   : ')
-      ENDIF
-      !
+      ENDIF 
+	  !
    END SUBROUTINE blk_oce_2
 
@@ -855,5 +855,5 @@
       zcd_dui(:,:) = wndm_ice(:,:) * Cd_atm(:,:)
       
-      IF( ln_blk ) THEN 
+ !     IF( ln_blk ) THEN 
          ! ------------------------------------------------------------ !
          !    Wind stress relative to the moving ice ( U10m - U_ice )   !
@@ -874,14 +874,14 @@
          IF(ln_ctl)   CALL prt_ctl( tab2d_1=putaui  , clinfo1=' blk_ice: putaui : '   &
             &                     , tab2d_2=pvtaui  , clinfo2='          pvtaui : ' )
-      ELSE
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               pcd_dui(ji,jj) = zcd_dui(ji,jj)
-               pseni  (ji,jj) = wndm_ice(ji,jj) * Ch_atm(ji,jj)
-               pevpi  (ji,jj) = wndm_ice(ji,jj) * Ce_atm(ji,jj)
-               pssqi  (ji,jj) = 11637800.0_wp * EXP( -5897.8_wp / (ptsui(ji,jj)+rt0) ) / zrhoa(ji,jj)
-            END DO
-         END DO
-      ENDIF
+ !     ELSE
+ !        DO jj = 1, jpj
+ !           DO ji = 1, jpi
+ !              pcd_dui(ji,jj) = zcd_dui(ji,jj)
+ !              pseni  (ji,jj) = wndm_ice(ji,jj) * Ch_atm(ji,jj)
+ !              pevpi  (ji,jj) = wndm_ice(ji,jj) * Ce_atm(ji,jj)
+ !              pssqi  (ji,jj) = 11637800.0_wp * EXP( -5897.8_wp / (ptsui(ji,jj)+rt0) ) / zrhoa(ji,jj)
+ !           END DO
+ !        END DO
+ !     ENDIF
       !
       IF(ln_ctl)  CALL prt_ctl(tab2d_1=wndm_ice  , clinfo1=' blk_ice: wndm_ice : ')