Index: NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_algo_coare3p0.F90
===================================================================
--- NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_algo_coare3p0.F90	(revision 11291)
+++ NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_algo_coare3p0.F90	(revision 11329)
@@ -57,5 +57,6 @@
       &                      Cd, Ch, Ce, t_zu, q_zu, U_blk,      &
       &                      Cdn, Chn, Cen,                      &
-      &                      Qsw, rad_lw, slp, Tsk_b             )
+      &                      Qsw, rad_lw, slp,                   &
+      &                      Tsk_b )
       !!----------------------------------------------------------------------
       !!                      ***  ROUTINE  turb_coare3p0  ***
@@ -64,5 +65,5 @@
       !!                fluxes according to Fairall et al. (2003)
       !!                If relevant (zt /= zu), adjust temperature and humidity from height zt to zu
-      !!                Returns the effective bulk wind speed at 10m to be used in the bulk formulas
+      !!                Returns the effective bulk wind speed at zu to be used in the bulk formulas
       !!
       !!                Applies the cool-skin warm-layer correction of the SST to T_s
@@ -304,12 +305,12 @@
       Ch   = ztmp0*t_star/dt_zu
       Ce   = ztmp0*q_star/dq_zu
-      !
+
       ztmp1 = zu + z0
       Cdn = vkarmn*vkarmn / (log(ztmp1/z0 )*log(ztmp1/z0 ))
       Chn = vkarmn*vkarmn / (log(ztmp1/z0t)*log(ztmp1/z0t))
       Cen = Chn
-      !
+
       IF( .NOT. l_zt_equal_zu ) DEALLOCATE( zeta_t )
-      !
+
    END SUBROUTINE turb_coare3p0
 
Index: NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_algo_coare3p6.F90
===================================================================
--- NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_algo_coare3p6.F90	(revision 11291)
+++ NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_algo_coare3p6.F90	(revision 11329)
@@ -57,5 +57,6 @@
       &                      Cd, Ch, Ce, t_zu, q_zu, U_blk,      &
       &                      Cdn, Chn, Cen,                      &
-      &                      Qsw, rad_lw, slp, Tsk_b             )
+      &                      Qsw, rad_lw, slp,                   &
+      &                      Tsk_b )
       !!----------------------------------------------------------------------
       !!                      ***  ROUTINE  turb_coare3p6  ***
@@ -64,5 +65,5 @@
       !!                fluxes according to Fairall et al. (2003)
       !!                If relevant (zt /= zu), adjust temperature and humidity from height zt to zu
-      !!                Returns the effective bulk wind speed at 10m to be used in the bulk formulas
+      !!                Returns the effective bulk wind speed at zu to be used in the bulk formulas
       !!
       !!                Applies the cool-skin warm-layer correction of the SST to T_s
@@ -304,12 +305,12 @@
       Ch   = ztmp0*t_star/dt_zu
       Ce   = ztmp0*q_star/dq_zu
-      !
+
       ztmp1 = zu + z0
       Cdn = vkarmn*vkarmn / (log(ztmp1/z0 )*log(ztmp1/z0 ))
       Chn = vkarmn*vkarmn / (log(ztmp1/z0t)*log(ztmp1/z0t))
       Cen = Chn
-      !
+
       IF( .NOT. l_zt_equal_zu ) DEALLOCATE( zeta_t )
-      !
+
    END SUBROUTINE turb_coare3p6
 
Index: NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_algo_ecmwf.F90
===================================================================
--- NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_algo_ecmwf.F90	(revision 11291)
+++ NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_algo_ecmwf.F90	(revision 11329)
@@ -60,15 +60,16 @@
 CONTAINS
 
-   SUBROUTINE TURB_ECMWF( zt, zu, T_s, t_zt, q_s, q_zt, U_zu, &
-      &                   Cd, Ch, Ce, t_zu, q_zu, U_blk,      &
-      &                   Cdn, Chn, Cen,                      &
-      &                   Qsw, rad_lw, slp, Tsk_b             )
-      !!----------------------------------------------------------------------------------
-      !!                      ***  ROUTINE  turb_ecmwf  ***
+   SUBROUTINE turb_ecmwf( zt, zu, T_s, t_zt, q_s, q_zt, U_zu, &
+      &                      Cd, Ch, Ce, t_zu, q_zu, U_blk,      &
+      &                      Cdn, Chn, Cen,                      &
+      &                      Qsw, rad_lw, slp,                   &
+      &                      Tsk_b )
+      !!----------------------------------------------------------------------
+       !!                      ***  ROUTINE  turb_ecmwf  ***
       !!
       !! ** Purpose :   Computes turbulent transfert coefficients of surface
       !!                fluxes according to IFS doc. (cycle 40)
       !!                If relevant (zt /= zu), adjust temperature and humidity from height zt to zu
-      !!                Returns the effective bulk wind speed at 10m to be used in the bulk formulas
+      !!                Returns the effective bulk wind speed at zu to be used in the bulk formulas
       !!
       !!                Applies the cool-skin warm-layer correction of the SST to T_s